# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from ..core.request_options import RequestOptions
from ..types.test_suite_tests_paginated_response import TestSuiteTestsPaginatedResponse
from .raw_client import AsyncRawTestSuiteTestsClient, RawTestSuiteTestsClient
from .types.test_suite_test_controller_create_request import TestSuiteTestControllerCreateRequest
from .types.test_suite_test_controller_create_response import TestSuiteTestControllerCreateResponse
from .types.test_suite_test_controller_find_all_paginated_request_sort_order import (
    TestSuiteTestControllerFindAllPaginatedRequestSortOrder,
)
from .types.test_suite_test_controller_find_one_response import TestSuiteTestControllerFindOneResponse
from .types.test_suite_test_controller_remove_response import TestSuiteTestControllerRemoveResponse
from .types.test_suite_test_controller_update_request import TestSuiteTestControllerUpdateRequest
from .types.test_suite_test_controller_update_response import TestSuiteTestControllerUpdateResponse

# this is used as the default value for optional parameters
OMIT = typing.cast(typing.Any, ...)


class TestSuiteTestsClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawTestSuiteTestsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawTestSuiteTestsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawTestSuiteTestsClient
        """
        return self._raw_client

    def test_suite_test_controller_find_all_paginated(
        self,
        test_suite_id: str,
        *,
        page: typing.Optional[float] = None,
        sort_order: typing.Optional[TestSuiteTestControllerFindAllPaginatedRequestSortOrder] = None,
        limit: typing.Optional[float] = None,
        created_at_gt: typing.Optional[dt.datetime] = None,
        created_at_lt: typing.Optional[dt.datetime] = None,
        created_at_ge: typing.Optional[dt.datetime] = None,
        created_at_le: typing.Optional[dt.datetime] = None,
        updated_at_gt: typing.Optional[dt.datetime] = None,
        updated_at_lt: typing.Optional[dt.datetime] = None,
        updated_at_ge: typing.Optional[dt.datetime] = None,
        updated_at_le: typing.Optional[dt.datetime] = None,
        request_options: typing.Optional[RequestOptions] = None,
    ) -> TestSuiteTestsPaginatedResponse:
        """
        Parameters
        ----------
        test_suite_id : str

        page : typing.Optional[float]
            This is the page number to return. Defaults to 1.

        sort_order : typing.Optional[TestSuiteTestControllerFindAllPaginatedRequestSortOrder]
            This is the sort order for pagination. Defaults to 'DESC'.

        limit : typing.Optional[float]
            This is the maximum number of items to return. Defaults to 100.

        created_at_gt : typing.Optional[dt.datetime]
            This will return items where the createdAt is greater than the specified value.

        created_at_lt : typing.Optional[dt.datetime]
            This will return items where the createdAt is less than the specified value.

        created_at_ge : typing.Optional[dt.datetime]
            This will return items where the createdAt is greater than or equal to the specified value.

        created_at_le : typing.Optional[dt.datetime]
            This will return items where the createdAt is less than or equal to the specified value.

        updated_at_gt : typing.Optional[dt.datetime]
            This will return items where the updatedAt is greater than the specified value.

        updated_at_lt : typing.Optional[dt.datetime]
            This will return items where the updatedAt is less than the specified value.

        updated_at_ge : typing.Optional[dt.datetime]
            This will return items where the updatedAt is greater than or equal to the specified value.

        updated_at_le : typing.Optional[dt.datetime]
            This will return items where the updatedAt is less than or equal to the specified value.

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        TestSuiteTestsPaginatedResponse


        Examples
        --------
        from vapi import Vapi
        client = Vapi(token="YOUR_TOKEN", )
        client.test_suite_tests.test_suite_test_controller_find_all_paginated(test_suite_id='testSuiteId', )
        """
        _response = self._raw_client.test_suite_test_controller_find_all_paginated(
            test_suite_id,
            page=page,
            sort_order=sort_order,
            limit=limit,
            created_at_gt=created_at_gt,
            created_at_lt=created_at_lt,
            created_at_ge=created_at_ge,
            created_at_le=created_at_le,
            updated_at_gt=updated_at_gt,
            updated_at_lt=updated_at_lt,
            updated_at_ge=updated_at_ge,
            updated_at_le=updated_at_le,
            request_options=request_options,
        )
        return _response.data

    def test_suite_test_controller_create(
        self,
        test_suite_id: str,
        *,
        request: TestSuiteTestControllerCreateRequest,
        request_options: typing.Optional[RequestOptions] = None,
    ) -> TestSuiteTestControllerCreateResponse:
        """
        Parameters
        ----------
        test_suite_id : str

        request : TestSuiteTestControllerCreateRequest

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        TestSuiteTestControllerCreateResponse


        Examples
        --------
        from vapi import Vapi
        from vapi import CreateTestSuiteTestVoiceDto
        from vapi import TestSuiteTestScorerAi
        client = Vapi(token="YOUR_TOKEN", )
        client.test_suite_tests.test_suite_test_controller_create(test_suite_id='testSuiteId', request=CreateTestSuiteTestVoiceDto(scorers=[TestSuiteTestScorerAi(rubric='rubric', )], script='script', ), )
        """
        _response = self._raw_client.test_suite_test_controller_create(
            test_suite_id, request=request, request_options=request_options
        )
        return _response.data

    def test_suite_test_controller_find_one(
        self, test_suite_id: str, id: str, *, request_options: typing.Optional[RequestOptions] = None
    ) -> TestSuiteTestControllerFindOneResponse:
        """
        Parameters
        ----------
        test_suite_id : str

        id : str

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        TestSuiteTestControllerFindOneResponse


        Examples
        --------
        from vapi import Vapi
        client = Vapi(token="YOUR_TOKEN", )
        client.test_suite_tests.test_suite_test_controller_find_one(test_suite_id='testSuiteId', id='id', )
        """
        _response = self._raw_client.test_suite_test_controller_find_one(
            test_suite_id, id, request_options=request_options
        )
        return _response.data

    def test_suite_test_controller_remove(
        self, test_suite_id: str, id: str, *, request_options: typing.Optional[RequestOptions] = None
    ) -> TestSuiteTestControllerRemoveResponse:
        """
        Parameters
        ----------
        test_suite_id : str

        id : str

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        TestSuiteTestControllerRemoveResponse


        Examples
        --------
        from vapi import Vapi
        client = Vapi(token="YOUR_TOKEN", )
        client.test_suite_tests.test_suite_test_controller_remove(test_suite_id='testSuiteId', id='id', )
        """
        _response = self._raw_client.test_suite_test_controller_remove(
            test_suite_id, id, request_options=request_options
        )
        return _response.data

    def test_suite_test_controller_update(
        self,
        test_suite_id: str,
        id: str,
        *,
        request: TestSuiteTestControllerUpdateRequest,
        request_options: typing.Optional[RequestOptions] = None,
    ) -> TestSuiteTestControllerUpdateResponse:
        """
        Parameters
        ----------
        test_suite_id : str

        id : str

        request : TestSuiteTestControllerUpdateRequest

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        TestSuiteTestControllerUpdateResponse


        Examples
        --------
        from vapi import Vapi
        from vapi import UpdateTestSuiteTestVoiceDto
        client = Vapi(token="YOUR_TOKEN", )
        client.test_suite_tests.test_suite_test_controller_update(test_suite_id='testSuiteId', id='id', request=UpdateTestSuiteTestVoiceDto(), )
        """
        _response = self._raw_client.test_suite_test_controller_update(
            test_suite_id, id, request=request, request_options=request_options
        )
        return _response.data


class AsyncTestSuiteTestsClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawTestSuiteTestsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawTestSuiteTestsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawTestSuiteTestsClient
        """
        return self._raw_client

    async def test_suite_test_controller_find_all_paginated(
        self,
        test_suite_id: str,
        *,
        page: typing.Optional[float] = None,
        sort_order: typing.Optional[TestSuiteTestControllerFindAllPaginatedRequestSortOrder] = None,
        limit: typing.Optional[float] = None,
        created_at_gt: typing.Optional[dt.datetime] = None,
        created_at_lt: typing.Optional[dt.datetime] = None,
        created_at_ge: typing.Optional[dt.datetime] = None,
        created_at_le: typing.Optional[dt.datetime] = None,
        updated_at_gt: typing.Optional[dt.datetime] = None,
        updated_at_lt: typing.Optional[dt.datetime] = None,
        updated_at_ge: typing.Optional[dt.datetime] = None,
        updated_at_le: typing.Optional[dt.datetime] = None,
        request_options: typing.Optional[RequestOptions] = None,
    ) -> TestSuiteTestsPaginatedResponse:
        """
        Parameters
        ----------
        test_suite_id : str

        page : typing.Optional[float]
            This is the page number to return. Defaults to 1.

        sort_order : typing.Optional[TestSuiteTestControllerFindAllPaginatedRequestSortOrder]
            This is the sort order for pagination. Defaults to 'DESC'.

        limit : typing.Optional[float]
            This is the maximum number of items to return. Defaults to 100.

        created_at_gt : typing.Optional[dt.datetime]
            This will return items where the createdAt is greater than the specified value.

        created_at_lt : typing.Optional[dt.datetime]
            This will return items where the createdAt is less than the specified value.

        created_at_ge : typing.Optional[dt.datetime]
            This will return items where the createdAt is greater than or equal to the specified value.

        created_at_le : typing.Optional[dt.datetime]
            This will return items where the createdAt is less than or equal to the specified value.

        updated_at_gt : typing.Optional[dt.datetime]
            This will return items where the updatedAt is greater than the specified value.

        updated_at_lt : typing.Optional[dt.datetime]
            This will return items where the updatedAt is less than the specified value.

        updated_at_ge : typing.Optional[dt.datetime]
            This will return items where the updatedAt is greater than or equal to the specified value.

        updated_at_le : typing.Optional[dt.datetime]
            This will return items where the updatedAt is less than or equal to the specified value.

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        TestSuiteTestsPaginatedResponse


        Examples
        --------
        from vapi import AsyncVapi
        import asyncio
        client = AsyncVapi(token="YOUR_TOKEN", )
        async def main() -> None:
            await client.test_suite_tests.test_suite_test_controller_find_all_paginated(test_suite_id='testSuiteId', )
        asyncio.run(main())
        """
        _response = await self._raw_client.test_suite_test_controller_find_all_paginated(
            test_suite_id,
            page=page,
            sort_order=sort_order,
            limit=limit,
            created_at_gt=created_at_gt,
            created_at_lt=created_at_lt,
            created_at_ge=created_at_ge,
            created_at_le=created_at_le,
            updated_at_gt=updated_at_gt,
            updated_at_lt=updated_at_lt,
            updated_at_ge=updated_at_ge,
            updated_at_le=updated_at_le,
            request_options=request_options,
        )
        return _response.data

    async def test_suite_test_controller_create(
        self,
        test_suite_id: str,
        *,
        request: TestSuiteTestControllerCreateRequest,
        request_options: typing.Optional[RequestOptions] = None,
    ) -> TestSuiteTestControllerCreateResponse:
        """
        Parameters
        ----------
        test_suite_id : str

        request : TestSuiteTestControllerCreateRequest

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        TestSuiteTestControllerCreateResponse


        Examples
        --------
        from vapi import AsyncVapi
        from vapi import CreateTestSuiteTestVoiceDto
        from vapi import TestSuiteTestScorerAi
        import asyncio
        client = AsyncVapi(token="YOUR_TOKEN", )
        async def main() -> None:
            await client.test_suite_tests.test_suite_test_controller_create(test_suite_id='testSuiteId', request=CreateTestSuiteTestVoiceDto(scorers=[TestSuiteTestScorerAi(rubric='rubric', )], script='script', ), )
        asyncio.run(main())
        """
        _response = await self._raw_client.test_suite_test_controller_create(
            test_suite_id, request=request, request_options=request_options
        )
        return _response.data

    async def test_suite_test_controller_find_one(
        self, test_suite_id: str, id: str, *, request_options: typing.Optional[RequestOptions] = None
    ) -> TestSuiteTestControllerFindOneResponse:
        """
        Parameters
        ----------
        test_suite_id : str

        id : str

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        TestSuiteTestControllerFindOneResponse


        Examples
        --------
        from vapi import AsyncVapi
        import asyncio
        client = AsyncVapi(token="YOUR_TOKEN", )
        async def main() -> None:
            await client.test_suite_tests.test_suite_test_controller_find_one(test_suite_id='testSuiteId', id='id', )
        asyncio.run(main())
        """
        _response = await self._raw_client.test_suite_test_controller_find_one(
            test_suite_id, id, request_options=request_options
        )
        return _response.data

    async def test_suite_test_controller_remove(
        self, test_suite_id: str, id: str, *, request_options: typing.Optional[RequestOptions] = None
    ) -> TestSuiteTestControllerRemoveResponse:
        """
        Parameters
        ----------
        test_suite_id : str

        id : str

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        TestSuiteTestControllerRemoveResponse


        Examples
        --------
        from vapi import AsyncVapi
        import asyncio
        client = AsyncVapi(token="YOUR_TOKEN", )
        async def main() -> None:
            await client.test_suite_tests.test_suite_test_controller_remove(test_suite_id='testSuiteId', id='id', )
        asyncio.run(main())
        """
        _response = await self._raw_client.test_suite_test_controller_remove(
            test_suite_id, id, request_options=request_options
        )
        return _response.data

    async def test_suite_test_controller_update(
        self,
        test_suite_id: str,
        id: str,
        *,
        request: TestSuiteTestControllerUpdateRequest,
        request_options: typing.Optional[RequestOptions] = None,
    ) -> TestSuiteTestControllerUpdateResponse:
        """
        Parameters
        ----------
        test_suite_id : str

        id : str

        request : TestSuiteTestControllerUpdateRequest

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        TestSuiteTestControllerUpdateResponse


        Examples
        --------
        from vapi import AsyncVapi
        from vapi import UpdateTestSuiteTestVoiceDto
        import asyncio
        client = AsyncVapi(token="YOUR_TOKEN", )
        async def main() -> None:
            await client.test_suite_tests.test_suite_test_controller_update(test_suite_id='testSuiteId', id='id', request=UpdateTestSuiteTestVoiceDto(), )
        asyncio.run(main())
        """
        _response = await self._raw_client.test_suite_test_controller_update(
            test_suite_id, id, request=request, request_options=request_options
        )
        return _response.data
