# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
import typing_extensions
from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.serialization import FieldMetadata
from ..core.unchecked_base_model import UncheckedBaseModel
from .call import Call
from .client_message_conversation_update_messages_item import ClientMessageConversationUpdateMessagesItem
from .client_message_conversation_update_phone_number import ClientMessageConversationUpdatePhoneNumber
from .create_assistant_dto import CreateAssistantDto
from .create_customer_dto import CreateCustomerDto
from .open_ai_message import OpenAiMessage


class ClientMessageConversationUpdate(UncheckedBaseModel):
    phone_number: typing_extensions.Annotated[
        typing.Optional[ClientMessageConversationUpdatePhoneNumber], FieldMetadata(alias="phoneNumber")
    ] = pydantic.Field(default=None)
    """
    This is the phone number that the message is associated with.
    """

    type: typing.Literal["conversation-update"] = pydantic.Field(default="conversation-update")
    """
    This is the type of the message. "conversation-update" is sent when an update is committed to the conversation history.
    """

    messages: typing.Optional[typing.List[ClientMessageConversationUpdateMessagesItem]] = pydantic.Field(default=None)
    """
    This is the most up-to-date conversation history at the time the message is sent.
    """

    messages_open_ai_formatted: typing_extensions.Annotated[
        typing.List[OpenAiMessage], FieldMetadata(alias="messagesOpenAIFormatted")
    ] = pydantic.Field()
    """
    This is the most up-to-date conversation history at the time the message is sent, formatted for OpenAI.
    """

    timestamp: typing.Optional[float] = pydantic.Field(default=None)
    """
    This is the timestamp of the message.
    """

    call: typing.Optional[Call] = pydantic.Field(default=None)
    """
    This is the call that the message is associated with.
    """

    customer: typing.Optional[CreateCustomerDto] = pydantic.Field(default=None)
    """
    This is the customer that the message is associated with.
    """

    assistant: typing.Optional[CreateAssistantDto] = pydantic.Field(default=None)
    """
    This is the assistant that the message is associated with.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
