# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
import typing_extensions
from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.serialization import FieldMetadata
from ..core.unchecked_base_model import UncheckedBaseModel
from .call import Call
from .client_message_speech_update_phone_number import ClientMessageSpeechUpdatePhoneNumber
from .client_message_speech_update_role import ClientMessageSpeechUpdateRole
from .client_message_speech_update_status import ClientMessageSpeechUpdateStatus
from .create_assistant_dto import CreateAssistantDto
from .create_customer_dto import CreateCustomerDto


class ClientMessageSpeechUpdate(UncheckedBaseModel):
    phone_number: typing_extensions.Annotated[
        typing.Optional[ClientMessageSpeechUpdatePhoneNumber], FieldMetadata(alias="phoneNumber")
    ] = pydantic.Field(default=None)
    """
    This is the phone number that the message is associated with.
    """

    type: typing.Literal["speech-update"] = pydantic.Field(default="speech-update")
    """
    This is the type of the message. "speech-update" is sent whenever assistant or user start or stop speaking.
    """

    status: ClientMessageSpeechUpdateStatus = pydantic.Field()
    """
    This is the status of the speech update.
    """

    role: ClientMessageSpeechUpdateRole = pydantic.Field()
    """
    This is the role which the speech update is for.
    """

    turn: typing.Optional[float] = pydantic.Field(default=None)
    """
    This is the turn number of the speech update (0-indexed).
    """

    timestamp: typing.Optional[float] = pydantic.Field(default=None)
    """
    This is the timestamp of the message.
    """

    call: typing.Optional[Call] = pydantic.Field(default=None)
    """
    This is the call that the message is associated with.
    """

    customer: typing.Optional[CreateCustomerDto] = pydantic.Field(default=None)
    """
    This is the customer that the message is associated with.
    """

    assistant: typing.Optional[CreateAssistantDto] = pydantic.Field(default=None)
    """
    This is the assistant that the message is associated with.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
