# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
import typing_extensions
from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.serialization import FieldMetadata
from ..core.unchecked_base_model import UncheckedBaseModel
from .artifact import Artifact
from .call import Call
from .create_assistant_dto import CreateAssistantDto
from .create_customer_dto import CreateCustomerDto
from .server_message_transfer_update_destination import ServerMessageTransferUpdateDestination
from .server_message_transfer_update_phone_number import ServerMessageTransferUpdatePhoneNumber


class ServerMessageTransferUpdate(UncheckedBaseModel):
    phone_number: typing_extensions.Annotated[
        typing.Optional[ServerMessageTransferUpdatePhoneNumber], FieldMetadata(alias="phoneNumber")
    ] = pydantic.Field(default=None)
    """
    This is the phone number that the message is associated with.
    """

    type: typing.Literal["transfer-update"] = pydantic.Field(default="transfer-update")
    """
    This is the type of the message. "transfer-update" is sent whenever a transfer happens.
    """

    destination: typing.Optional[ServerMessageTransferUpdateDestination] = pydantic.Field(default=None)
    """
    This is the destination of the transfer.
    """

    timestamp: typing.Optional[float] = pydantic.Field(default=None)
    """
    This is the timestamp of the message.
    """

    artifact: typing.Optional[Artifact] = pydantic.Field(default=None)
    """
    This is a live version of the `call.artifact`.
    
    This matches what is stored on `call.artifact` after the call.
    """

    assistant: typing.Optional[CreateAssistantDto] = pydantic.Field(default=None)
    """
    This is the assistant that the message is associated with.
    """

    customer: typing.Optional[CreateCustomerDto] = pydantic.Field(default=None)
    """
    This is the customer that the message is associated with.
    """

    call: typing.Optional[Call] = pydantic.Field(default=None)
    """
    This is the call that the message is associated with.
    """

    to_assistant: typing_extensions.Annotated[
        typing.Optional[CreateAssistantDto], FieldMetadata(alias="toAssistant")
    ] = pydantic.Field(default=None)
    """
    This is the assistant that the call is being transferred to. This is only sent if `destination.type` is "assistant".
    """

    from_assistant: typing_extensions.Annotated[
        typing.Optional[CreateAssistantDto], FieldMetadata(alias="fromAssistant")
    ] = pydantic.Field(default=None)
    """
    This is the assistant that the call is being transferred from. This is only sent if `destination.type` is "assistant".
    """

    to_step_record: typing_extensions.Annotated[
        typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]], FieldMetadata(alias="toStepRecord")
    ] = pydantic.Field(default=None)
    """
    This is the step that the conversation moved to.
    """

    from_step_record: typing_extensions.Annotated[
        typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]], FieldMetadata(alias="fromStepRecord")
    ] = pydantic.Field(default=None)
    """
    This is the step that the conversation moved from. =
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
